#include "table.h"
/* 
 * Verifica se una tavola e' piena.
 *
 * Ritorna true (non 0) se la tavola e' piena, 0 altrimenti.
 */
int table_full(struct table *t){
	return 0;
}

/* 
 * Inizializza una tavola.
 la table deve essere gi allocata..(t=!NULL && t->htable!=NULL)
 */
void table_init(struct table *t){
	htable_init(t->htable);/*inizializza la tavola hash*/
	t->ls = NULL;
}

/* 
 * Inserisce in una tavola un nuovo elemento.
 *
 * struct table *t: e' la tavola in cui inserire l'elemento
 * char *key: la chiave dell'elemento da inserire
 * Ritorna il puntatore all'elemento inserito o NULL in caso di errore 
 * (eg, tavola piena) o elemento gia' presente. Il campo info del nuovo
 * elemento inserito viene inizializzato a NULL.
 */
struct tabelem *table_ins(struct table *t, char *key){
	struct telist *p;
	if(t!=NULL){
		if(htable_ins(t->htable, key)!=NULL){/*se ha successo l'inserimento nella 	tavola hash*/
			p = t->ls;/*p: variabile d'appoggio per l'inserimento in testa alla lista*/
			t->ls = malloc(sizeof(struct telist));
			if(t->ls!=NULL){
				t->ls->next = p;
				t->ls->el = htable_search(t->htable, key);
				if(t->ls->el!=NULL) t->ls->el->info = NULL;
				return t->ls->el;
			}
		}
	}
	return NULL;
}

/* 
 * Cerca in una tavola un elemento.
 *
 * struct table *t: e' la tavola in cui ricercare l'elemento
 * char *key: la chiave dell'elemento da cercare
 * Ritorna il puntatore all'elemento cercato, se questo e' presente nella
 * tavola, o NULL, nel caso in cui l'elemento non e' presente.
 */
struct tabelem *table_search(struct table *t, char *key){
	if(t!=NULL) return htable_search(t->htable, key);
	return NULL;
}
