/* 
 * Laboratorio di Programmazione - A.A. 2004-05
 * Canali A-D (Nicola Galesi), P-Z (Stefano Guerini)
 * 
 * test-parser.c
 *
 * Main per la verifica del parser
 */

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "parser.h"

typedef struct node {
    char *link; /* link */
    int link_pos; /* numero d'ordine del link */
    int pos; /* parole che precedono il link */
    struct node *next;
} *list;

list add_node(list l, char *str, int lp, int p) {
    list nd = malloc(sizeof(struct node));
    
    assert(nd);
    nd->link = str;
    nd->link_pos = lp;
    nd->pos = p;
    nd->next = l;
    return nd;
}

void print_list(list l) {
    if (l != NULL) {
	print_list(l->next);
	printf("%-3d %-3d \"%s\"\n", l->link_pos, l->pos, l->link);
    }
}

void parse_file(FILE *fp) {
    struct info_word *piw;
    list ls = NULL;
    int count = 0;
    int pos = 0;

    while ((piw = next_word(fp)) != NULL) {
	if (count != piw->link_pos) { /* letto nuovo link */
	    /* inserisci in lista e aggiona i contatori */
	    ls = add_node(ls, piw->file_link, piw->link_pos, pos);
	    count = piw->link_pos;
	    pos = piw->word_pos;
	}
        print_word(piw);
    }
    printf("  ---- lista link ----\n");
    print_list(ls);
}

int main(int argc, char *argv[]) {
    char *fname;
    FILE *fp;
    int i = 0;

    if (--argc == 0) {
	parse_file(stdin);
	return 0;
    }
    argv++;
    for (fname = *argv++; argc-- > 0; fname = *argv++) {
	printf("  ****  %s  ****\n", fname);
	if ((fp = open_ipertesto(fname)) == NULL) {
	    printf("    ====> Impossibile aprire il file\n");
	    i++;
	}
	else {
	    parse_file(fp);
	    close_ipertesto(fp);
	}
	printf("  ****    ****\n");
    }
    return i;
}
