
#include "table.h"

int hash_funct(HASHTABLE ht, char *k){
	int i, j, part, sum = 0;
	for(i=0, part=0; k[i]!='\0'; i++){
		part = k[i];
		for(j=0; j<i; j++) part *= 256;
		part %= ht->hdim;
		sum += part;
	}
	sum %= ht->hdim;
	return sum;
}

void htable_init(HASHTABLE ht){//vuole (ht=!NULL && ht->array!=NULL)
	int i;
	ht->hdim = HTABDIM;
	for(i=0; i<ht->hdim; i++) ht->array[i] = NULL;/*inizializza i puntatori*/
}

int htable_full(HASHTABLE ht){
	return 0;
}

/*se la tavola  piena o l'elemento  gi presente ritorna null*/
struct tabelem *htable_ins(HASHTABLE ht, char *k){
	HTABELEM temp;
	int index = hash_funct(ht, k);
	if(htable_full(ht) || htable_search(ht, k)!=NULL || index>=ht->hdim) return NULL;
	temp = malloc(sizeof(struct htabelem));/*alloca lo spazio salva il puntatore in temp*/
	temp->data = malloc(sizeof(struct tabelem));/*alloca il campo data e salva il puntatore*/
	temp->data->key = malloc((strlen(k)+1)*sizeof(char));
	strcpy(temp->data->key, k);/*salva la chiave*/
	temp->next = ht->array[index];/*inserimento in testa*/
	ht->array[index] = temp;
	return temp->data;
}

struct tabelem *htable_search(HASHTABLE ht, char *k){
	HTABELEM temp;
	if(ht!=NULL){
		temp = ht->array[hash_funct(ht, k)];
		for( ; temp != NULL; temp=temp->next){ 
			if(!strcmp(k, temp->data->key)) return temp->data;
		}
	}
	return NULL;
}
