/* 
 * Laboratorio di Programmazione - A.A. 2004-05
 * Canali A-D (Nicola Galesi), P-Z (Stefano Guerini)
 * 
 * nodes.h
 */

#if !defined __NODES_H

#define __NODES_H 1

/*
 * path della dir contenente le pagine
 */
extern char *main_path;

/*
 * Attributi delle parole in un ipertesto
 */
typedef enum {normal, small, large} size;


/*
 * Informazioni associate ad ogni occorrenza di una parola
 */
struct info_word {
    char   *parola;     /* parola */ 
    int     word_pos;   /* posizione parole nel file */ 
    int     title;      /* vero se parola nel titolo */
    int     italic;     /* vero se parola in corsivo */
    int     bold;       /* vero se parola in grassetto */
    size    word_size;  /* dimensione*/
    char   *file_link;  /* in caso di link attivo, contiene il nome
                           della pagina (file) del link */ 
    int     link_pos;   /* posizione del link nel file */
};

/*
 * Elemento della lista delle occorrenze di una parola
 */
struct elem_hitlist {
    struct info_word *info_occ_word; /* informazioni  sulla particolare 
					occorrenza dell parola */ 
    struct elem_hitlist *next_elem;  /* puntatore al prossimo 
					elemento della hitlist */ 
};

/*
 * Elemento del dizionario locale di una pagina.
 * Il dizionario locale e' realizzato con una lista collegata
 */
struct  elem_diz_loc  { 
    char *parola; /* entry del dizionario locale */  
    struct elem_hitlist *hitlist;  /*  puntatore alla hitlist 
				       corrispondente a parola*/ 
    int dim; /*  numero di occorrenze di parola 
		 = dimensione hitlist */ 
    struct elem_diz_loc *next_word; /*  prossima entry 
					nel dizionario locale */ 
};

/*
 * Elemento della lista (locale) dei link in un ipertesto
 */
struct info_link  { 
    struct tabelem *ptr_pagina;  /* puntatore all'elemento del 
				    dizionario ipertesti*/    
    int molteplicita;            /* numero link alla pagina  */
    struct info_link *next;     /* prossimo elemento */
};

/*
 * Informazioni associate ad ogni ipertesto
 * Da memorizzare nel campo info dell'elemento della tavola
 * corrsipondente all'ipertesto
 */
struct info_ipertesto  { 
    struct info_link *lista_in;     /* lista pagine che puntano */ 
    struct info_link *lista_out;    /* lista pagine puntate */ 
    struct elem_diz_loc  *diz_loc;  /* dizionario locale */ 
    int page_rank;                  /* page rank del documento */
};

/* 
 * Crea una nuova tavola in cui le chiavi degli elementi sono
 * i file ipertesto contenuti in "dirname".
 *
 * Ritorna il puntatore alla nuova tavola creata, o NULL in caso di errore.
 */
struct table *create_node_table(char *dirname);


/* 
 * Completa il dizionario degli ipertesti, dopo che create_node_table
 * ha creato la tavola con i nomi degli ipertesti.
 *
 * Deve determinare e memorizzare il campo info di ogni elemnto della
 * tavola *ptb ricevuta in ingresso.
 */
void create_diz_ipertesti(struct table *ptb);

#endif
